# Research Grants

{% hint style="info" %}
Please note that in all urls & code samples you'll need to replace`:username` and `:corporation` with appropriate values
{% endhint %}

## Get All Research Grants

<mark style="color:green;">`GET`</mark> [**/v2/organization/:corporation/expert/:username/researchgrant**](https://public-api.expertfile.com/v2/organization/:corporation/expert/:username/researchgrant/)

**Headers**

| Name          | Value              |
| ------------- | ------------------ |
| Content-Type  | `application/json` |
| Authorization | `Bearer <token>`   |

**Url**

<table><thead><tr><th width="339.3333333333333">Name</th><th>Type</th><th>Description</th></tr></thead><tbody><tr><td>corporation</td><td>number</td><td>Corporation ID</td></tr><tr><td>username</td><td>string</td><td>Unique username</td></tr></tbody></table>

**Response**

{% tabs %}
{% tab title="200" %}

```json
 {
  data: [
    {
      id: 1,
      title: 'Research Grant Title',
      organization: 'Organization',
      url: 'https://grant.com',
      details: 'Details',
      date: 0,
      amount: '10',
      currency: '$'
    },
  ],
  success: true
}
```

{% endtab %}
{% endtabs %}

Code

{% tabs %}
{% tab title="Node" %}

```javascript
const data = new URLSearchParams();
const accessToken = `<ACCESS TOKEN>`

fetch('https://public-api.expertfile.com/v2/organization/:corporation/expert/:username/researchgrant', {
    method: 'GET',
    headers: {
        'Content-Type': 'application/x-www-form-urlencoded',
        'Authorization': `Bearer ${accessToken}`
    }
})
.then(response => response.json())
.then(json => {
    const { success, data } = json

    if (success) {
        const grants = data;
        console.log('all grants', grants)
    }

})
.catch(error => console.error(error));
```

{% endtab %}

{% tab title="PHP" %}

```php
$accessToken = urlencode('<ACCESS TOKEN>');
$url = 'https://public-api.expertfile.com/v2/organization/:corporation/expert/:username/researchgrant';

$ch = curl_init($url);
curl_setopt(
    $ch,
    CURLOPT_HTTPHEADER,
    array('Content-Type: application/x-www-form-urlencoded', 'Authorization: Bearer ' . $accessToken)
);
curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);

$response = curl_exec($ch);
$json = json_decode($response);

if($json->success){
    var_dump($json->data);
}

curl_close($ch);

```

{% endtab %}

{% tab title="Curl" %}

```
curl https://public-api.expertfile.com/v2/organization/:corporation/expert/:username/researchgrant \
    -H "Content-Type: application/json" \
    -H "Authorization: Bearer <ACCESS TOKEN>"
```

{% endtab %}
{% endtabs %}

## Get Individual Research Grant

<mark style="color:green;">`GET`</mark> [**/v2/organization/:corporation/expert/:username/researchgrant/:id**](https://public-api.expertfile.com/v2/organization/:corporation/expert/:username/researchgrant/:id)

**Headers**

| Name          | Value              |
| ------------- | ------------------ |
| Content-Type  | `application/json` |
| Authorization | `Bearer <token>`   |

**Url**

<table><thead><tr><th width="339.3333333333333">Name</th><th>Type</th><th>Description</th></tr></thead><tbody><tr><td>corporation</td><td>number</td><td>Corporation ID</td></tr><tr><td>username</td><td>string</td><td>Unique username</td></tr><tr><td>id</td><td>number</td><td>Research Grant ID</td></tr></tbody></table>

**Response**

{% tabs %}
{% tab title="200" %}

```json
 {
  data: [
    {
      id: 1,
      title: 'Research Grant Title',
      organization: 'Organization',
      url: 'https://grant.com',
      details: 'Details',
      date: 0,
      amount: '10',
      currency: '$'
    },
  ],
  success: true
}
```

{% endtab %}
{% endtabs %}

Code

{% tabs %}
{% tab title="Node" %}

```javascript
const accessToken = `<ACCESS CODE>`

fetch('https://public-api.expertfile.com/v2/organization/:corporation/expert/:username/researchgrant/:id', {
    method: 'GET',
    headers: {
        'Content-Type': 'application/x-www-form-urlencoded',
        'Authorization': `Bearer ${accessToken}`
    }
})
.then(response => response.json())
.then(json => {
    const { success, data, error } = json

    if (success) {
        console.log('grant', data)
    }

})
.catch(error => console.error(error));
```

{% endtab %}

{% tab title="PHP" %}

```php
$accessToken = urlencode('<ACCESS TOKEN>');
$url = 'https://public-api.expertfile.com/v2/organization/:corporation/expert/:username/researchgrant/:id';

$ch = curl_init($url);
curl_setopt(
    $ch,
    CURLOPT_HTTPHEADER,
    array('Content-Type: application/x-www-form-urlencoded', 'Authorization: Bearer ' . $accessToken)
);
curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);

$response = curl_exec($ch);
$json = json_decode($response);

if($json->success){
    var_dump($json->data);
}

curl_close($ch);
```

{% endtab %}

{% tab title="Curl" %}

```
curl -X GET https://public-api.expertfile.com/v2/organization/:corporation/expert/:username/researchgrant/:id \
    -H "Content-Type: application/json" \
    -H "Authorization: Bearer <ACCESS TOKEN>"     
```

{% endtab %}
{% endtabs %}

## Create Research Grant

<mark style="color:blue;">`POST`</mark> [**/v2/organization/:corporation/expert/:username/researchgrant**](https://public-api.expertfile.com/v2/organization/:corporation/expert/:username/researchgrant/)

**Headers**

| Name          | Value              |
| ------------- | ------------------ |
| Content-Type  | `application/json` |
| Authorization | `Bearer <token>`   |

**Url**

<table><thead><tr><th width="339.3333333333333">Name</th><th>Type</th><th>Description</th></tr></thead><tbody><tr><td>corporation</td><td>number</td><td>Corporation ID</td></tr><tr><td>username</td><td>string</td><td>Unique username</td></tr></tbody></table>

**Body**

<table><thead><tr><th width="339.3333333333333">Name</th><th>Type</th><th>Description</th></tr></thead><tbody><tr><td>title<mark style="color:red;">*</mark></td><td>string</td><td>Grant Title</td></tr><tr><td>organization<mark style="color:red;">*</mark></td><td>string</td><td>Grant Organization</td></tr><tr><td>details<mark style="color:red;">*</mark></td><td>string</td><td>Grant Detail</td></tr><tr><td>date</td><td>unix timestamp</td><td>Grant Date</td></tr><tr><td>url</td><td>string</td><td>Grant Url</td></tr><tr><td>amount</td><td>string</td><td>Grant Amount</td></tr><tr><td>currency</td><td>string</td><td>Grant Currency</td></tr></tbody></table>

**Response**

{% tabs %}
{% tab title="200" %}

```json
{ 
    data: { 
        id: 1
    }, 
    success: true 
}
```

{% endtab %}
{% endtabs %}

Code

{% tabs %}
{% tab title="Node" %}

```javascript
const data = new URLSearchParams();
const accessToken = `<ACCESS TOKEN>`

data.append('title', 'Grant title');
data.append('organization', 'Grant organization');
data.append('details', 'Grant details...');
data.append('amount', '100');
data.append('currency', '$');
data.append('date', 1702530000);
data.append('url', 'https://myurl.com');

fetch('https://public-api.expertfile.com/v2/organization/:corporation/expert/:username/researchgrant', {
    method: 'POST',
    headers: {
        'Content-Type': 'application/x-www-form-urlencoded',
        'Authorization': `Bearer ${accessToken}`
    },
    body: data
})
.then(response => response.json())
.then(json => {
    const { success, data, error } = json

    if (success) {
        const { id } = data
        console.log('New grant id', id)
    }

})
.catch(error => console.error(error));
```

{% endtab %}

{% tab title="PHP" %}

```php
$accessToken = urlencode('<ACCESS TOKEN>');

$url = 'https://public-api.expertfile.com/v2/organization/:corporation/expert/:username/researchgrant';
$data = ['title' => 'Grant title', 'organization' => 'Grant organization', 'details' => 'Grant details...','amount' => '100','currency' => '$', 'date' => 1702530000, 'url' => 'https://myurl.com'];

$ch = curl_init($url);
curl_setopt(
    $ch,
    CURLOPT_HTTPHEADER,
    array('Content-Type: application/x-www-form-urlencoded', 'Authorization: Bearer ' . $accessToken)
);
curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
curl_setopt($ch, CURLOPT_POSTFIELDS, http_build_query($data));

$response = curl_exec($ch);
$json = json_decode($response);

if($json->success){
    var_dump($json->data);
}

curl_close($ch)
```

{% endtab %}

{% tab title="Curl" %}

```
curl -X POST https://public-api.expertfile.com/v2/organization/:corporation/expert/:username/researchgrant \
    -H "Content-Type: application/json" \
    -H "Authorization: Bearer <ACCESS TOKEN>" \
    -d '{"title": "Grant title", "organization": "Grant organization", "details": "Grant details...", "amount": "100", "currency": "$", "date": 1702530000, "url": "https://myurl.com"}'
```

{% endtab %}
{% endtabs %}

## Update Research Grant

<mark style="color:blue;">`PUT`</mark>[ **/v2/organization/:corporation/expert/:username/researchgrant/:id**](https://public-api.expertfile.com/v2/organization/:corporation/expert/:username/researchgrant/:id)

**Headers**

| Name          | Value              |
| ------------- | ------------------ |
| Content-Type  | `application/json` |
| Authorization | `Bearer <token>`   |

**Url**

<table><thead><tr><th width="339.3333333333333">Name</th><th>Type</th><th>Description</th></tr></thead><tbody><tr><td>corporation</td><td>number</td><td>Corporation ID</td></tr><tr><td>username</td><td>string</td><td>Unique username</td></tr><tr><td>id</td><td>number</td><td>Research Grant ID</td></tr></tbody></table>

**Body**

<table><thead><tr><th width="339.3333333333333">Name</th><th>Type</th><th>Description</th></tr></thead><tbody><tr><td>title<mark style="color:red;">*</mark></td><td>string</td><td>Grant Title</td></tr><tr><td>organization<mark style="color:red;">*</mark></td><td>string</td><td>Grant Organization</td></tr><tr><td>details<mark style="color:red;">*</mark></td><td>string</td><td>Grant Detail</td></tr><tr><td>date</td><td>unix timestamp</td><td>Grant Date</td></tr><tr><td>url</td><td>string</td><td>Grant Url</td></tr><tr><td>amount</td><td>string</td><td>Grant Amount</td></tr><tr><td>currency</td><td>string</td><td>Grant Currency</td></tr></tbody></table>

**Response**

{% tabs %}
{% tab title="200" %}

```json
{ 
    data: { 
        id: 1, 
        updated: true 
    }, 
    success: true 
}
```

{% endtab %}
{% endtabs %}

Code

{% tabs %}
{% tab title="Node" %}

```javascript
const data = new URLSearchParams();
const accessToken = `<ACCESS TOKEN>`

data.append('title', 'Grant title');
data.append('organization', 'Grant organization');
data.append('details', 'Grant details...');
data.append('amount', '100');
data.append('currency', '$');
data.append('date', 1702530000);
data.append('url', 'https://myurl.com');

fetch('https://public-api.expertfile.com/v2/organization/:corporation/expert/:username/researchgrant/:id', {
    method: 'PUT',
    headers: {
        'Content-Type': 'application/x-www-form-urlencoded',
        'Authorization': `Bearer ${accessToken}`
    },
    body: data
})
.then(response => response.json())
.then(json => {
    const { success, data, error } = json

    if (success) {
        const { id } = data
        console.log('New patent id', id)
    }

})
.catch(error => console.error(error));

```

{% endtab %}

{% tab title="PHP" %}

```php
$accessToken = urlencode('<ACCESS TOKEN>');

$url = 'https://public-api.expertfile.com/v2/organization/:corporation/expert/:username/researchgrant/:id';
$data = ['title' => 'Grant title', 'organization' => 'Grant organization', 'details' => 'Grant details...','amount' => '100','currency' => '$', 'date' => 1702530000, 'url' => 'https://myurl.com'];

$ch = curl_init($url);
curl_setopt(
    $ch,
    CURLOPT_HTTPHEADER,
    array('Content-Type: application/x-www-form-urlencoded', 'Authorization: Bearer ' . $accessToken)
);
curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
curl_setopt($ch, CURLOPT_PUT, http_build_query($data));

$response = curl_exec($ch);
$json = json_decode($response);

if($json->success){
    var_dump($json->data);
}

curl_close($ch)
```

{% endtab %}

{% tab title="Curl" %}

```
curl -X PUT https://public-api.expertfile.com/v2/organization/:corporation/expert/:username/researchgrant/:id \
    -H "Content-Type: application/json" \
    -H "Authorization: Bearer <ACCESS TOKEN>" \
    -d '{"title": "Grant title", "organization": "Grant organization", "details": "Grant details...", "amount": "100", "currency": "$", "date": 1702530000, "url": "https://myurl.com"}'
```

{% endtab %}
{% endtabs %}

## Delete Research Grant

<mark style="color:red;">`DELETE`</mark> [**/v2/organization/:corporation/expert/:username/researchgrant/:id**](https://public-api.expertfile.com/v2/organization/:corporation/expert/:username/researchgrant/:id)

**Headers**

| Name          | Value              |
| ------------- | ------------------ |
| Content-Type  | `application/json` |
| Authorization | `Bearer <token>`   |

**Url**

<table><thead><tr><th width="339.3333333333333">Name</th><th>Type</th><th>Description</th></tr></thead><tbody><tr><td>corporation</td><td>number</td><td>Corporation ID</td></tr><tr><td>username</td><td>string</td><td>Unique username</td></tr><tr><td>id</td><td>number</td><td>Research Grant ID</td></tr></tbody></table>

**Response**

{% tabs %}
{% tab title="200" %}

```json
{ 
    data: { 
        deleted: true, 
        id: 1 
    }, 
    success: true 
}
```

{% endtab %}
{% endtabs %}

Code

{% tabs %}
{% tab title="Node" %}

```javascript
const accessToken = `<ACCESS TOKEN>`

fetch('https://public-api.expertfile.com/v2/organization/:corporation/expert/:username/researchgrant/:id', {
    method: 'DELETE',
    headers: {
        'Content-Type': 'application/x-www-form-urlencoded',
        'Authorization': `Bearer ${accessToken}`
    }
})
.then(response => response.json())
.then(json => {
    const { success, data, error } = json

    if (success) {
        const { id } = data
        console.log('Deleted grant id', id)
    }

})
.catch(error => console.error(error));

```

{% endtab %}

{% tab title="PHP" %}

```php
$accessToken = urlencode('<ACCESS TOKEN>');

$url = 'https://public-api.expertfile.com/v2/organization/:corporation/expert/:username/testimonial/:id';

$ch = curl_init($url);
curl_setopt(
    $ch,
    CURLOPT_HTTPHEADER,
    array('Content-Type: application/x-www-form-urlencoded', 'Authorization: Bearer ' . $accessToken)
);
curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
curl_setopt($ch, CURLOPT_CUSTOMREQUEST, "DELETE");

$response = curl_exec($ch);
$json = json_decode($response);

if($json->success){
    var_dump($json->data);
}

curl_close($ch);
```

{% endtab %}

{% tab title="Curl" %}

```
curl -X DELETE https://public-api.expertfile.com/v2/organization/:corporation/expert/:username/testimonial/:id \
    -H "Content-Type: application/json" \
    -H "Authorization: Bearer <ACCESS TOKEN>"
```

{% endtab %}
{% endtabs %}


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://developer.expertfile.com/reference/api-reference/experts/expert-profile/research-grants.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
